using Microsoft.Xna.Framework;

namespace Kav.Data
{
    public struct MeshSpriteDrawData : ICullable
    {
        public MeshSprite MeshSprite { get; }
        public SpriteBillboardConstraint BillboardConstraint { get; }
        public Matrix TransformMatrix { get; }
        public UVData UVData { get; }

        public BoundingBox BoundingBox => MeshSprite.BoundingBox;

        public MeshSpriteDrawData(
            MeshSprite meshSprite,
            SpriteBillboardConstraint billboardConstraint,
            Matrix transformMatrix,
            UVData uvData
        ) {
            MeshSprite = meshSprite;
            BillboardConstraint = billboardConstraint;
            TransformMatrix = transformMatrix;
            UVData = uvData;
        }
    }
}
